<?php
namespace nur\sery\db;

interface IDatabase {
  function beginTransaction(): void;

  function commit(): void;

  function rollback(): void;

  /** @return int|bool en fonction des implémentations */
  function exec($query, ?array $params=null);

  function get($query, ?array $params=null, bool $entireRow=false);

  function one($query, ?array $params=null): ?array;

  function all($query, ?array $params=null, $primaryKeys=null): iterable;
}
